﻿using System;
using System.Text;
using System.Web.Mvc;
using SpiceLogic.PayPalCtrlForWPS.Controls;

namespace Test_Mvc_Web.Controllers
{
    public class SubscriptionController : Controller
    {
        //
        // GET: /Subscription/

        public ActionResult Index()
        {
            return View();
        }

        /// <summary>
        /// Handles the IPN.
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string HandleIPN()
        {
            IPNHandler myIpnHandler = new IPNHandler
            {
                NotifyValidateDestination = FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox
            };

            DedicatedIPNEventArgs e = myIpnHandler.GetDefaultDataForMVC();
            if (e.SubscriptionInfo.Event == BasicIPNPDTSubscriptionInfo.SubscriptionEvents.SignUp)
            {
                StringBuilder myIpnStringBuilder = new StringBuilder();
                myIpnStringBuilder.AppendLine("Additional Data Item -> Customer's Name = " +
                                              e.AdditionalDataItems["Customer's Name"]);
                myIpnStringBuilder.AppendLine("Subscriber ID : " + e.SubscriptionInfo.SubscriberID);
                myIpnStringBuilder.AppendLine("Recurring Time : " + e.SubscriptionInfo.RecurringTimes);
                myIpnStringBuilder.AppendLine("Subscription Number : " + e.SubscriptionInfo.SubscriptionNumber);
                myIpnStringBuilder.AppendLine("Subscription Name : " + e.SubscriptionInfo.SubscriptionName);
                myIpnStringBuilder.AppendLine("Charset : " + e.CharSet);
                myIpnStringBuilder.AppendLine("Notify Version : " + e.IPN.NotifyVersion);
                myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName);
                myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City);
                myIpnStringBuilder.AppendLine("Subscription Event : " + e.SubscriptionInfo.Event);
                myIpnStringBuilder.AppendLine("Subscription Regular Rate : " + e.SubscriptionInfo.McRegularRate);
                myIpnStringBuilder.AppendLine("Subscription Billing Cycle : " + e.SubscriptionInfo.BillingCycle + " " + e.SubscriptionInfo.BillingCycleUnit);
                myIpnStringBuilder.AppendLine("Trial Amount 1 : " + e.SubscriptionInfo.TrialAmount1);
                myIpnStringBuilder.AppendLine("Trial Cycle 1: " + e.SubscriptionInfo.TrialPeriod1 + " " + e.SubscriptionInfo.TrialPeriod1Unit);
                myIpnStringBuilder.AppendLine();
                myIpnStringBuilder.AppendLine(e.IPN.ToString());
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(string.Format("~/App_Data/suscr_ipn_signup_{0}.txt", e.SubscriptionInfo.SubscriberID)), myIpnStringBuilder.ToString());
            }
            else if (e.SubscriptionInfo.Event == BasicIPNPDTSubscriptionInfo.SubscriptionEvents.Cancel)
            {
                StringBuilder myIpnStringBuilder = new StringBuilder();
                myIpnStringBuilder.AppendLine("Additional Data Item -> Customer's Name = " +
                                              e.AdditionalDataItems["Customer's Name"]);
                myIpnStringBuilder.AppendLine("Subscriber ID : " + e.SubscriptionInfo.SubscriberID);
                myIpnStringBuilder.AppendLine("Recurring Time : " + e.SubscriptionInfo.RecurringTimes);
                myIpnStringBuilder.AppendLine("Subscription Number : " + e.SubscriptionInfo.SubscriptionNumber);
                myIpnStringBuilder.AppendLine("Subscription Name : " + e.SubscriptionInfo.SubscriptionName);
                myIpnStringBuilder.AppendLine("Charset : " + e.CharSet);
                myIpnStringBuilder.AppendLine("Notify Version : " + e.IPN.NotifyVersion);
                myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName);
                myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City);
                myIpnStringBuilder.AppendLine("Subscription Event : " + e.SubscriptionInfo.Event);
                myIpnStringBuilder.AppendLine();
                myIpnStringBuilder.AppendLine(e.IPN.ToString());
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(string.Format("~/App_Data/suscr_ipn_cancel_{0}.txt", e.SubscriptionInfo.SubscriberID)), myIpnStringBuilder.ToString());
            }
            else if (e.SubscriptionInfo.Event == BasicIPNPDTSubscriptionInfo.SubscriptionEvents.Payment)
            {
                StringBuilder myIpnStringBuilder = new StringBuilder();
                myIpnStringBuilder.AppendLine("Additional Data Item -> Customer's Name = " +
                                              e.AdditionalDataItems["Customer's Name"]);
                myIpnStringBuilder.AppendLine("Subscriber ID : " + e.SubscriptionInfo.SubscriberID);
                myIpnStringBuilder.AppendLine("Subscription Number : " + e.SubscriptionInfo.SubscriptionNumber);
                myIpnStringBuilder.AppendLine("Mc Gross : " + e.PaymentInfo.McGross);
                myIpnStringBuilder.AppendLine("Subscription Name : " + e.SubscriptionInfo.SubscriptionName);
                myIpnStringBuilder.AppendLine("Charset : " + e.CharSet);
                myIpnStringBuilder.AppendLine("Notify Version : " + e.IPN.NotifyVersion);
                myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName);
                myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City);
                myIpnStringBuilder.AppendLine("Subscription Event : " + e.SubscriptionInfo.Event);
                myIpnStringBuilder.AppendLine();
                myIpnStringBuilder.AppendLine(e.IPN.ToString());
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(string.Format("~/App_Data/suscr_ipn_payment_{0}.txt", e.SubscriptionInfo.SubscriberID)), myIpnStringBuilder.ToString());
            }
            else
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(string.Format("~/App_Data/suscr_ipn_default_{0}.txt", e.SubscriptionInfo.SubscriberID)), e.IPN.ToString());

            if(e.IPN.Status == PayPalIPN.StatusCodes.Verified)
            {
                // Add user to Role for Subscription.
            }

            return string.Empty;
        }

        /// <summary>
        /// Payspal returned.
        /// </summary>
        /// <returns></returns>
        public ActionResult PayPalReturned()
        {
            PayPalReturnHandler myReturnHandler = new PayPalReturnHandler
            {
                PDTAuthenticationToken = "IoSLdmDHmJZ9K2K98zASAG4y_DNx_MwgLMgGrF2gzrCwRnNo3VlU_bAw2DK",
                NotifySyncDestination = FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox
            };

            SubscriptionReturnedEventArgs e = myReturnHandler.GetSubscriptionDataForMVC();

            ViewData["pdtData"] = e.PDT.ToString();

            string greetingMsg = string.Format("Hello [{0}] !", e.AdditionalDataItems["Customer's Name"]);

            if (e.IsPaymentCancelled)
            {
                ViewData["isPaymentCancelled"] = true;
                greetingMsg += " Sorry, payment is cancelled";
            }
            else
            {
                ViewData["txnId"] = e.TransactionID;

                greetingMsg += "Thank you for the payment.";
                ViewData["pdtStatus"] = e.PDT.Status;
                ViewData["isPaymentCancelled"] = false;

                if (e.PDT.Status == PayPalPDT.StatusCodes.SUCCESS)
                {
                    ViewData["subscription_name"] = e.SubscriptionInfo.SubscriptionName;
                    ViewData["subscription_number"] = e.SubscriptionInfo.SubscriptionNumber;
                    ViewData["subscriber_id"] = e.SubscriptionInfo.SubscriberID;
                    ViewData["SubscriptionEvent"] = e.SubscriptionInfo.Event;
                }
            }

            ViewData["returnMessage"] = greetingMsg;

            return View();
        }

        /// <summary>
        /// Retrieves the ipn.
        /// </summary>
        /// <returns></returns>
        public ActionResult RetrieveIpn(string subscriberId, bool isForPaymentEvent)
        {
            string filePathForValidIPN = HttpContext.Request.MapPath(string.Format("~/App_Data/suscr_ipn_{0}_{1}.txt", (isForPaymentEvent ? "payment" : "signup"), subscriberId));
            if (System.IO.File.Exists(filePathForValidIPN))
            {
                ViewData["ipnData"] = System.IO.File.ReadAllText(filePathForValidIPN);
                System.IO.File.Delete(filePathForValidIPN);
            }
            else
                ViewData["ipnData"] = string.Format("The IPN for Subscriber ID : {0} is still not available. It is natural for Sand box that the IPN arrives little longer than PayPal live site. Please try after a while.", subscriberId);

            ViewData["subscriber_id"] = subscriberId;

            return View("PayPalReturned");
        }
    }
}
