﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<dynamic>" %>
<%@ Import Namespace="SpiceLogic.PayPalCtrlForWPS.Controls" %>
<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Xml" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Index
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <h2>Welcome to SpiceLogic Landscape showroom.</h2> 
     This sample application will show you how you can use UploadCompleteCart button control to transfer your 
    3rd party shopping cart items to the PayPal hosted shopping cart. In order to simulate a 3rd party shopping 
    cart, we will use a table which will show a list of eBooks read from an XML file stored in App_Data folder. 
    We will assume that those eBooks are added to the 3rd party shopping cart. Finally, The UploadCompleteCartButton 
    will be used to offer Checkout. The following Upload Complete Cart button is populated programmatically from the 
    View Page by reading the XML file. Please check that code to learn how you can populate a Upload Complete Cart 
    button in the same way. 
       <%
   
        UploadCompleteCartButton myButton = new UploadCompleteCartButton
        {
            BusinessEmailOrMerchantID = "7VYHPUUWHHTLA",
        };

        myButton.PayPalFormSubmission.PostDestination = 
            FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox;

        myButton.PayPalIPN.Custom_IPN_Url = "~/Upload3rdPartyShoppingCart/HandleIPN";
        myButton.PayPalReturn.Custom_CompletedReturnURL = "~/Upload3rdPartyShoppingCart/PayPalReturned";

        myButton.PayPalDisplayPage.ShippingAddress =
            PayPalDisplayPageSettings.ShippingAddressOptions.ShippingAddressOptional;
        myButton.PayPalDisplayPage.HeaderBorderColor = Color.Orange;
        myButton.PayPalDisplayPage.HeaderBgColor = Color.LightYellow;
        myButton.PayPalDisplayPage.PayFlowBgColor = Color.LightSteelBlue;
        myButton.PayPalDisplayPage.HeaderImageURL = "~/Content/images/SpiceLogicBanner.jpg";

        myButton.AdditionalDataItems["Customer's Name"] = "James Paul";
        myButton.AdditionalDataItems["Cart Name"] = "eBooks";
           
        string eBookXmlFile = HttpContext.Current.Request.MapPath("~/App_Data/eBooks.xml");
        if(!System.IO.File.Exists(eBookXmlFile))
        {%>
             The eBook Xml file does not exist
        <%}   
        else
        {
            %>
            <br /><br />
             <table style="background-color:White;border-color:#E7E7FF;border-width:1px;border-style:None;width:489px;border-collapse:collapse;">
		     <tr style="background-color:#4A3C8C;font-weight:bold;">
		    	<th scope="col">title</th><th scope="col">author</th><th scope="col">price</th>
		    </tr>
          <%

            XmlDocument myXmlDoc = new XmlDocument();
            myXmlDoc.Load(eBookXmlFile);
            XmlNodeList bookNodes = myXmlDoc.SelectNodes("/eBooks/book");
            if (bookNodes != null)
            {
                foreach(XmlNode aNode in bookNodes)
                {
                    if (aNode.Attributes != null)
                    {
                        string id = aNode.Attributes["id"].Value;
                        string title = aNode.Attributes["title"].Value;
                        string author = aNode.Attributes["author"].Value;
                        string price = aNode.Attributes["price"].Value;
                        
                        %>
                            <tr style="color:#4A3C8C;background-color:#E7E7FF;">
                               <td><%= title %></td><td><%= author %></td><td><%= price %></td>
                            </tr>
                        <%

                        myButton.PayPalCartItems.Add(new PayPalItem(title, id, 1, decimal.Parse(price)));
                    }
                }
            }
           %>
	    </table>
         <br />
             <%= myButton.RenderForMVC()%> 
        <%}
    %>
        <p>Trial version works only with PayPal SANDBOX. Once License Key is applied, it 
                    will work with Live PayPal site or any URL of your choice..
                    <br />
        Before starting to test this website, visit 
                    <a target="_blank" href="https://developer.paypal.com">https://developer.paypal.com</a>
                     
                    &nbsp;this page and login to your Developer Central Account.
                    <br />
        If you do not have any account with PayPal Developer Central, please create an 
        account.
                    </p>

</asp:Content>
