﻿Imports SpiceLogic.PayPalCtrlForWPS.Controls

Namespace Controllers
    Public Class AcceptingDonationController
        Inherits Controller
        '
        ' GET: /AcceptingDonation/

        Public Function Index() As ActionResult
            Return View()
        End Function

        ''' <summary>
        ''' Handles the IPN.
        ''' </summary>
        ''' <returns></returns>
        <HttpPost()> _
        Public Function HandleIPN() As String
            Dim myIpnHandler As New IPNHandler() With { _
             .NotifyValidateDestination = FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox _
            }

            Dim e As DonationIPNEventArgs = myIpnHandler.GetDonationDataForMVC()

            '#Region "---------------------------- Just logging the IPN Session as a proof that IPN event was fired --------------"

            Dim myIpnStringBuilder As New StringBuilder()
            myIpnStringBuilder.AppendLine("Transaction ID : " + e.TransactionID)

            myIpnStringBuilder.AppendLine("Donation Number : " + e.DonationNumber)
            myIpnStringBuilder.AppendLine("Mc Gross : " + e.PaymentInfo.McGross.ToString())
            myIpnStringBuilder.AppendLine("Discount Amount : " + e.PaymentInfo.DiscountAmount.ToString())
            myIpnStringBuilder.AppendLine("Charset : " + e.CharSet)
            myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName)
            myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City)
            myIpnStringBuilder.AppendLine("Is this ipn resent ? : " + e.IPN.IsResent.ToString())
            myIpnStringBuilder.AppendLine("Is this ipn from SandBox ? : " + e.IPN.IsSandBox.ToString())
            myIpnStringBuilder.AppendLine()
            myIpnStringBuilder.AppendLine()
            myIpnStringBuilder.AppendLine(e.IPN.ToString())

            System.IO.File.WriteAllText(HttpContext.Request.MapPath(String.Format("~/App_Data/ipn_{0}.txt", e.TransactionID)), myIpnStringBuilder.ToString())

            '#End Region

            If e.IPN.Status = PayPalIPN.StatusCodes.Verified Then
                '********************** Data Collection *****************

                Dim donationName As String = e.DonationName
                Dim donationNumber As String = e.DonationNumber
                Dim donatedAmount As Decimal = e.PaymentInfo.McGross
                Dim donationDateTime As DateTime = e.PaymentInfo.PaymentDateTime

                ' etc............. etc........

                ' Send email to the donator "Thank you for your donation".
                ' Send email to the webmaster about the payment.
                ' Log the transaction to your database.
                Dim TransactionID As String = e.TransactionID
            End If

            Return String.Empty
        End Function

        ''' <summary>
        ''' Payspal returned.
        ''' </summary>
        ''' <returns></returns>
        Public Function PayPalReturned() As ActionResult
            Dim myReturnHandler As New PayPalReturnHandler() With { _
             .PDTAuthenticationToken = "IoSLdmDHmJZ9K2K98zASAG4y_DNx_MwgLMgGrF2gzrCwRnNo3VlU_bAw2DK", _
             .NotifySyncDestination = FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox _
            }

            Dim e As DonationReturnedEventArgs = myReturnHandler.GetDonationDataForMVC()

            ViewData("pdtData") = e.PDT.ToString()

            Dim greetingMsg As String = String.Format("Hello [{0}] !", e.AdditionalDataItems("Customer's Name"))

            If e.IsPaymentCancelled Then
                ViewData("isPaymentCancelled") = True
                greetingMsg += " Sorry, donation is cancelled"
            Else
                ViewData("txnId") = e.TransactionID

                greetingMsg += "Thank you for the donation."
                ViewData("pdtStatus") = e.PDT.Status
                ViewData("isPaymentCancelled") = False

                If e.PDT.Status = PayPalPDT.StatusCodes.SUCCESS Then
                    ViewData("item_name") = e.DonationName
                    ViewData("item_number") = e.DonationNumber
                    ViewData("paid_amount") = e.PaymentInfo.McGross
                End If
            End If

            ViewData("returnMessage") = greetingMsg

            Return View()
        End Function

        ''' <summary>
        ''' Retrieves the ipn.
        ''' </summary>
        ''' <returns></returns>
        <HttpPost()> _
        Public Function RetrieveIpn(ByVal txnId As String) As ActionResult
            Dim filePathForValidIPN As String = HttpContext.Request.MapPath(String.Format("~/App_Data/ipn_{0}.txt", txnId))
            If System.IO.File.Exists(filePathForValidIPN) Then
                ViewData("ipnData") = System.IO.File.ReadAllText(filePathForValidIPN)
                System.IO.File.Delete(filePathForValidIPN)
            Else
                ViewData("ipnData") = String.Format("The IPN for Txn ID : {0} is still not available. It is natural for Sand box that the IPN arrives little longer than PayPal live site. Please try after a while.", txnId)
            End If

            ViewData("txnId") = txnId

            Return View("PayPalReturned")
        End Function
    End Class
End Namespace