﻿Imports SpiceLogic.PayPalCtrlForWPS
Imports SpiceLogic.PayPalCtrlForWPS.Core
Imports SpiceLogic.PayPalCtrlForWPS.Controls

Namespace Controllers
    Public Class SubscriptionController
        Inherits System.Web.Mvc.Controller
        '
        ' GET: /Subscription/

        Public Function Index() As ActionResult
            Return View()
        End Function

        ''' <summary>
        ''' Handles the IPN.
        ''' </summary>
        ''' <returns></returns>
        <HttpPost()> _
        Public Function HandleIPN() As String
            Dim myIpnHandler As New IPNHandler() With { _
             .NotifyValidateDestination = FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox _
            }

            Dim e As DedicatedIPNEventArgs = myIpnHandler.GetDefaultDataForMVC()
            If e.SubscriptionInfo.Event = BasicIPNPDTSubscriptionInfo.SubscriptionEvents.SignUp Then
                Dim myIpnStringBuilder As New StringBuilder()
                myIpnStringBuilder.AppendLine("Additional Data Item -> Customer's Name = " + e.AdditionalDataItems("Customer's Name"))
                myIpnStringBuilder.AppendLine("Subscriber ID : " + e.SubscriptionInfo.SubscriberID)
                myIpnStringBuilder.AppendLine("Recurring Time : " + e.SubscriptionInfo.RecurringTimes.ToString())
                myIpnStringBuilder.AppendLine("Subscription Number : " + e.SubscriptionInfo.SubscriptionNumber)
                myIpnStringBuilder.AppendLine("Subscription Name : " + e.SubscriptionInfo.SubscriptionName)
                myIpnStringBuilder.AppendLine("Charset : " + e.CharSet)
                myIpnStringBuilder.AppendLine("Notify Version : " + e.IPN.NotifyVersion)
                myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName)
                myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City)
                myIpnStringBuilder.AppendLine("Subscription Event : " + e.SubscriptionInfo.Event.ToString())
                myIpnStringBuilder.AppendLine("Subscription Regular Rate : " + e.SubscriptionInfo.McRegularRate.ToString())
                myIpnStringBuilder.AppendLine("Subscription Billing Cycle : " + e.SubscriptionInfo.BillingCycle.ToString() + " " + e.SubscriptionInfo.BillingCycleUnit.ToString())
                myIpnStringBuilder.AppendLine("Trial Amount 1 : " + e.SubscriptionInfo.TrialAmount1.ToString())
                myIpnStringBuilder.AppendLine("Trial Cycle 1: " + e.SubscriptionInfo.TrialPeriod1.ToString() + " " + e.SubscriptionInfo.TrialPeriod1Unit.ToString())
                myIpnStringBuilder.AppendLine()
                myIpnStringBuilder.AppendLine(e.IPN.ToString())
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(String.Format("~/App_Data/suscr_ipn_signup_{0}.txt", e.SubscriptionInfo.SubscriberID)), myIpnStringBuilder.ToString())
            ElseIf e.SubscriptionInfo.Event = BasicIPNPDTSubscriptionInfo.SubscriptionEvents.Cancel Then
                Dim myIpnStringBuilder As New StringBuilder()
                myIpnStringBuilder.AppendLine("Additional Data Item -> Customer's Name = " + e.AdditionalDataItems("Customer's Name"))
                myIpnStringBuilder.AppendLine("Subscriber ID : " + e.SubscriptionInfo.SubscriberID)
                myIpnStringBuilder.AppendLine("Recurring Time : " + e.SubscriptionInfo.RecurringTimes.ToString())
                myIpnStringBuilder.AppendLine("Subscription Number : " + e.SubscriptionInfo.SubscriptionNumber)
                myIpnStringBuilder.AppendLine("Subscription Name : " + e.SubscriptionInfo.SubscriptionName)
                myIpnStringBuilder.AppendLine("Charset : " + e.CharSet)
                myIpnStringBuilder.AppendLine("Notify Version : " + e.IPN.NotifyVersion)
                myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName)
                myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City)
                myIpnStringBuilder.AppendLine("Subscription Event : " + e.SubscriptionInfo.Event.ToString())
                myIpnStringBuilder.AppendLine()
                myIpnStringBuilder.AppendLine(e.IPN.ToString())
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(String.Format("~/App_Data/suscr_ipn_cancel_{0}.txt", e.SubscriptionInfo.SubscriberID)), myIpnStringBuilder.ToString())
            ElseIf e.SubscriptionInfo.Event = BasicIPNPDTSubscriptionInfo.SubscriptionEvents.Payment Then
                Dim myIpnStringBuilder As New StringBuilder()
                myIpnStringBuilder.AppendLine("Additional Data Item -> Customer's Name = " + e.AdditionalDataItems("Customer's Name"))
                myIpnStringBuilder.AppendLine("Subscriber ID : " + e.SubscriptionInfo.SubscriberID)
                myIpnStringBuilder.AppendLine("Subscription Number : " + e.SubscriptionInfo.SubscriptionNumber)
                myIpnStringBuilder.AppendLine("Mc Gross : " + e.PaymentInfo.McGross.ToString())
                myIpnStringBuilder.AppendLine("Subscription Name : " + e.SubscriptionInfo.SubscriptionName)
                myIpnStringBuilder.AppendLine("Charset : " + e.CharSet)
                myIpnStringBuilder.AppendLine("Notify Version : " + e.IPN.NotifyVersion)
                myIpnStringBuilder.AppendLine("Buyer Last Name : " + e.BuyerInfo.LastName)
                myIpnStringBuilder.AppendLine("Buyer's Sipping Address -> City : " + e.BuyerInfo.ShippingAddress.City)
                myIpnStringBuilder.AppendLine("Subscription Event : " + e.SubscriptionInfo.Event.ToString())
                myIpnStringBuilder.AppendLine()
                myIpnStringBuilder.AppendLine(e.IPN.ToString())
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(String.Format("~/App_Data/suscr_ipn_payment_{0}.txt", e.SubscriptionInfo.SubscriberID)), myIpnStringBuilder.ToString())
            Else
                System.IO.File.WriteAllText(HttpContext.Request.MapPath(String.Format("~/App_Data/suscr_ipn_default_{0}.txt", e.SubscriptionInfo.SubscriberID)), e.IPN.ToString())
            End If

            ' Add user to Role for Subscription.
            If e.IPN.Status = PayPalIPN.StatusCodes.Verified Then
            End If

            Return String.Empty
        End Function

        ''' <summary>
        ''' Payspal returned.
        ''' </summary>
        ''' <returns></returns>
        Public Function PayPalReturned() As ActionResult
            Dim myReturnHandler As New PayPalReturnHandler() With { _
             .PDTAuthenticationToken = "IoSLdmDHmJZ9K2K98zASAG4y_DNx_MwgLMgGrF2gzrCwRnNo3VlU_bAw2DK", _
             .NotifySyncDestination = FormSubmissionSettings.PostActionDestinations.PayPal_Sandbox _
            }

            Dim e As SubscriptionReturnedEventArgs = myReturnHandler.GetSubscriptionDataForMVC()

            ViewData("pdtData") = e.PDT.ToString()

            Dim greetingMsg As String = String.Format("Hello [{0}] !", e.AdditionalDataItems("Customer's Name"))

            If e.IsPaymentCancelled Then
                ViewData("isPaymentCancelled") = True
                greetingMsg += " Sorry, payment is cancelled"
            Else
                ViewData("txnId") = e.TransactionID

                greetingMsg += "Thank you for the payment."
                ViewData("pdtStatus") = e.PDT.Status
                ViewData("isPaymentCancelled") = False

                If e.PDT.Status = PayPalPDT.StatusCodes.SUCCESS Then
                    ViewData("subscription_name") = e.SubscriptionInfo.SubscriptionName
                    ViewData("subscription_number") = e.SubscriptionInfo.SubscriptionNumber
                    ViewData("subscriber_id") = e.SubscriptionInfo.SubscriberID
                    ViewData("SubscriptionEvent") = e.SubscriptionInfo.[Event]
                End If
            End If

            ViewData("returnMessage") = greetingMsg

            Return View()
        End Function

        ''' <summary>
        ''' Retrieves the ipn.
        ''' </summary>
        ''' <returns></returns>
        Public Function RetrieveIpn(ByVal subscriberId As String, ByVal isForPaymentEvent As Boolean) As ActionResult
            Dim filePathForValidIPN As String = HttpContext.Request.MapPath(String.Format("~/App_Data/suscr_ipn_{0}_{1}.txt", (If(isForPaymentEvent, "payment", "signup")), subscriberId))
            If System.IO.File.Exists(filePathForValidIPN) Then
                ViewData("ipnData") = System.IO.File.ReadAllText(filePathForValidIPN)
                System.IO.File.Delete(filePathForValidIPN)
            Else
                ViewData("ipnData") = String.Format("The IPN for Subscriber ID : {0} is still not available. It is natural for Sand box that the IPN arrives little longer than PayPal live site. Please try after a while.", subscriberId)
            End If

            ViewData("subscriber_id") = subscriberId

            Return View("PayPalReturned")
        End Function

    End Class
End Namespace