﻿using System;
using System.Web.UI;
using SpiceLogic.PayPalCtrlForWPS.Controls;

/*****************************************************************************************************
 * This page is not highly documented. We have designed a page SellingSingleItem.aspx                *
 * and SellingSingleItem.aspx.cs with documentation to let you understand the usage of this control. *
 * If you read those files, you will find many useful information about this control. For simplicity *
 * the same documentation is not repeated here.                                                      *
 * ***************************************************************************************************/

public partial class SellingMultipleItems : Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    /// <summary>
    /// Handles the ReturnedForShopping event of the AddToCartButton1 control.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    protected void AddToCartButton1_ReturnedForShopping(object sender, EventArgs e)
    {
        AddToCartButton senderButton = sender as AddToCartButton;
        if (senderButton != null) 
            lblAddedItem.Text = senderButton.ItemName + " is just added to your shopping cart.";
    }

    /// <summary>
    /// Handles the Load event of the AddToCartButton1 control.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    protected void AddToCartButton1_Load(object sender, EventArgs e)
    {
        AddToCartButton senderButton = sender as AddToCartButton;
        if (senderButton != null)
            senderButton.Enabled = bool.Parse(senderButton.AdditionalDataItems["Enabled"] ?? "true");
    }

    /// <summary>
    /// Handles the Click event of the AddToCartButton1 control. Click event is fired only if a Click Event handler method is
    /// attached with the Click Event AND if the control is clicked. The Click event handler method will be executed before
    /// submitting form to PayPal. You can assign values to a PayPal Control's properties before submitting to PayPal Website.
    /// This approach is useful when you have a textbox in your page asking your buyer the quantity of the product he/she wants
    /// to buy and when the buyer click the BuyNow button, you want to update the Quantity information for this purchase. The
    /// control will POSTBACK ONLY IF you handle this Click Event. If you do not like POSTBACK for PayPal Control, then, set the
    /// property values of this control from Page_Load event or some other PostBack ASP.NET Control like ImageButton, Button,
    /// LinkButton etc control's PostBack event and do not handle Click Event. If you do not handle Click event of this control,
    /// then, clicking on this BuyNow button will transfer your visitor to PayPal (or SandBox) site from the client side without
    /// Server Round Trip which is the most desirable scenario.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="eventArgs">The <see cref="EventArgs"/> instance containing the event data.</param>
    protected void AddToCartButton1_Click(object sender, EventArgs eventArgs)
    {
        AddToCartButton senderButton = sender as AddToCartButton;
        if (senderButton != null) 
            senderButton.AdditionalDataItems["Enabled"] = false.ToString();
    }
}
