﻿Imports System
Imports System.Web.UI
Imports SpiceLogic.PayPalCtrlForWPS.Controls

' *****************************************************************************************************
' * This page is not highly documented. We have designed a page SellingSingleItem.aspx                *
' * and SellingSingleItem.aspx.vb with documentation to let you understand the usage of this control. *
' * If you read those files, you will find many useful information about this control. For simplicity *
' * the same documentation is not repeated here.                                                      *
' *****************************************************************************************************


Partial Public Class SellingMultipleItems
    Inherits Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

    ''' <summary>
    ''' Handles the ReturnedForShopping event of the AddToCartButton1 control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    Protected Sub AddToCartButton1_ReturnedForShopping(ByVal sender As Object, ByVal e As EventArgs)
        Dim senderButton As AddToCartButton = TryCast(sender, AddToCartButton)
        If senderButton IsNot Nothing Then
            lblAddedItem.Text = senderButton.ItemName + " is just added to your shopping cart."
        End If
    End Sub

    ''' <summary>
    ''' Handles the Load event of the AddToCartButton1 control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    Protected Sub AddToCartButton1_Load(ByVal sender As Object, ByVal e As EventArgs)
        Dim senderButton As AddToCartButton = TryCast(sender, AddToCartButton)
        If senderButton IsNot Nothing Then
            If senderButton.AdditionalDataItems("Enabled") = True Then
                senderButton.Enabled = True
            Else
                senderButton.Enabled = False
            End If
         End If
    End Sub

    ''' <summary>
    ''' Handles the Click event of the AddToCartButton1 control. Click event is fired only if a Click Event handler method is
    ''' attached with the Click Event AND if the control is clicked. The Click event handler method will be executed before
    ''' submitting form to PayPal. You can assign values to a PayPal Control's properties before submitting to PayPal Website.
    ''' This approach is useful when you have a textbox in your page asking your buyer the quantity of the product he/she wants
    ''' to buy and when the buyer click the BuyNow button, you want to update the Quantity information for this purchase. The
    ''' control will POSTBACK ONLY IF you handle this Click Event. If you do not like POSTBACK for PayPal Control, then, set the
    ''' property values of this control from Page_Load event or some other PostBack ASP.NET Control like ImageButton, Button,
    ''' LinkButton etc control's PostBack event and do not handle Click Event. If you do not handle Click event of this control,
    ''' then, clicking on this BuyNow button will transfer your visitor to PayPal (or SandBox) site from the client side without
    ''' Server Round Trip which is the most desirable scenario.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="System.Web.UI.ImageClickEventArgs"/> instance containing the event data.</param>
    Protected Sub AddToCartButton1_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim senderButton As AddToCartButton = TryCast(sender, AddToCartButton)
        If senderButton IsNot Nothing Then
            senderButton.AdditionalDataItems("Enabled") = False.ToString()
        End If
    End Sub
End Class
